unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, GLObjects, GLGeomObjects, GLScene,
  GLCoordinates, GLCrossPlatform, BaseClasses, GLWin32Viewer, Vcl.StdCtrls,
  VectorGeometry, Vcl.ExtCtrls, VectorTypes;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLDummyCube1: TGLDummyCube;
    GLTorus1: TGLTorus;
    GLArrowLine1: TGLArrowLine;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Panel1: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButtonNada: TRadioButton;
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
  private
    { Private declarations }
    ObGen : TGLCustomSceneObject;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject;
  Button: TMouseButton;
  Shift: TShiftState;
  X, Y: Integer);

begin
  Label2.Caption := '???';
  if CheckBox1.Checked AND (ssLeft in Shift) then begin
    ObGen := (GLSceneViewer1.Buffer.GetPickedObject(X, Y) as TGLCustomSceneObject);
    if ObGen <> nil then
      Label2.Caption := ObGen.Name;
  end;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
var
  ss  : TGLCoordinates3;
begin
  if ObGen <> nil then begin
    // Escala hacia abajo
    if RadioButton1.Checked then begin
      ss := ObGen.Scale;
      ss.Scale(0.95);
      ObGen.Scale := ss;
    end;

    // Rota en X restando
    if RadioButton2.Checked then begin
      ObGen.Pitch(-5);
    end;

    // Rota en Y restando
    if RadioButton3.Checked then begin
      ObGen.Turn(-5);
    end;

  end;


end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
var
  ss : TGLCoordinates3;
begin
  if ObGen <> nil then begin
    if RadioButton1.Checked then begin
      ss := ObGen.Scale;
      ss.Scale(1.05);
      ObGen.Scale := ss;
    end;

    // Rota en X sumando
    if RadioButton2.Checked then begin
      ObGen.Pitch(5);
    end;

    // Rota en Y sumando
    if RadioButton3.Checked then begin
      ObGen.Turn(5);
    end;

  end;

end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject;
  Shift: TShiftState;
  X, Y: Integer);
begin
//
end;

end.
